import java.util.ArrayList;
import java.util.concurrent.locks.*;

class Brusautomat{ //DETTE ER EN MONITOR

  static volatile int deltTeller = 0;

  int maxAntall;

  ArrayList<String> brusListe = new ArrayList<String>();
  Lock laas = new ReentrantLock();
  Condition ikkeTom = laas.newCondition();


  public Brusautomat(int max){
    maxAntall = max;
  }

  public String kjopBrus(){

    String brusen = "";
    laas.lock();

    try{
      while(brusListe.size() == 0){
        ikkeTom.await();
      }
      brusen = brusListe.remove(0);
    }
    catch(InterruptedException e){
      System.out.println(e);
    }
    finally{
      laas.unlock();
      return brusen;
    }
  }



  public void refill(){

    laas.lock();

    try{
      if(brusListe.size() == 0){
        for(int i = 0; i < maxAntall; i++){
          brusListe.add("Cola");
          ikkeTom.signalAll();
        }
      }
    }
    finally{
      laas.unlock();
    }

  }
}
